config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :quizzes
  resources :questions
  resources :quiz_sessions do
    resources :steps, controller: 'quiz_sessions/steps'
  end
  resources :users

  get "up" => "rails/health#show", as: :rails_health_check

  root "quizzes#index"
end

app/controllers/quizzes_controller.rb
class QuizzesController < ApplicationController
  before_action :set_quiz, only: %i[ show edit update destroy ]

  # GET /quizzes or /quizzes.json
  def index
    @quizzes = Quiz.all
  end

  # GET /quizzes/1 or /quizzes/1.json
  def show
  end

  # GET /quizzes/new
  def new
    @quiz = Quiz.new
  end

  # GET /quizzes/1/edit
  def edit
  end

  # POST /quizzes or /quizzes.json
  def create
    @quiz = Quiz.new(quiz_params)

    respond_to do |format|
      if @quiz.save
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully created." }
        format.json { render :show, status: :created, location: @quiz }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quizzes/1 or /quizzes/1.json
  def update
    respond_to do |format|
      if @quiz.update(quiz_params)
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully updated." }
        format.json { render :show, status: :ok, location: @quiz }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quizzes/1 or /quizzes/1.json
  def destroy
    @quiz.destroy!

    respond_to do |format|
      format.html { redirect_to quizzes_url, notice: "Quiz was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quiz
      @quiz = Quiz.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def quiz_params
      params.require(:quiz).permit(:identifier, :title, :description, :config, :result_calculator)
    end
end

app/helpers/quizzes_helper.rb
module QuizzesHelper
end

app/views/quizzes/_form.html.erb
<%= form_with(model: quiz) do |form| %>
  <% if quiz.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(quiz.errors.count, "error") %> prohibited this quiz from being saved:</h2>

      <ul>
        <% quiz.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :identifier, style: "display: block" %>
    <%= form.text_field :identifier %>
  </div>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :description, style: "display: block" %>
    <%= form.text_field :description %>
  </div>

  <div>
    <%= form.label :config, style: "display: block" %>
    <%= form.text_field :config %>
  </div>

  <div>
    <%= form.label :result_calculator, style: "display: block" %>
    <%= form.text_field :result_calculator %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quizzes/_quiz.html.erb
<div id="<%= dom_id quiz %>" style="border: 1px black solid; display: block; max-width: 300px; padding: 10px; margin: 10px">
  <div>
    <strong>Title:</strong>
    <%= quiz.title %>
  </div>

  <div>
    <strong>Details:</strong>
    <%= quiz.description %>
  </div>

  <%= button_to "Start!", { params: { quiz_session: { quiz_id: quiz.id } }, controller: 'quiz_sessions' }, method: :post  %>
</div>

app/views/quizzes/edit.html.erb
<h1>Editing quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Show this quiz", @quiz %> |
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/index.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<h1>Quizzes</h1>

<div id="quizzes">
  <% @quizzes.each do |quiz| %>
    <%= render quiz %>
  <% end %>
</div>

<%#= link_to "New quiz", new_quiz_path %>

app/views/quizzes/new.html.erb
<h1>New quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/show.html.erb
<p style="color: green"><%= notice %></p>
<p style="color: red"><%= error %></p>

<%= render @quiz %>

<div>
  <%= link_to "Edit this quiz", edit_quiz_path(@quiz) %> |
  <%= link_to "Back to quizzes", quizzes_path %>

  <%= button_to "Destroy this quiz", @quiz, method: :delete %>
</div>